/**
 * \file    Mimic_String.cpp
 * \author  Silvan Murer
 * \date    13 October 2022
 *
 * \brief   String class of genSDK GF implementation, based on Mimic_Node
 */

#include "features/Mimic_String.hpp"
#include "Mimic_Exception.hpp"

#define GENICAM_NO_AUTO_IMPLIB
#include "GenICam.h"

#include <memory>
#include <string>

using namespace GenApi;

namespace mimic {

    Mimic_String::Mimic_String() : Mimic_Node() { type = Type_e::STRING; };
    Mimic_String::Mimic_String(GenApi_3_4::INode* node) : Mimic_Node(node) { type = Type_e::STRING; };
    Mimic_String::~Mimic_String() { };

    std::variant<int64_t, double, bool, std::string> Mimic_String::getVariant(std::string name) 
    {
       return getValue();
    };
    void Mimic_String::setVariant(std::string name, std::variant<int64_t, double, bool, std::string> value)
    {
        try {
            setValue(std::get<std::string>(value));
        }
        catch (std::bad_variant_access const& e) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " is of type String! " + e.what(), -650);
        }
        catch (...) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " read failed!", -610);
        }

    }

    std::string Mimic_String::getValue()
    {
        if (!IsImplemented(node) || !IsAvailable(node) || !IsReadable(node)) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " is not readable!", -600);
        }
        try {
            return std::string(dynamic_cast<IString*>(node)->GetValue().c_str());
        }
        catch (...) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " read failed!", -610);
        }
    }
    void Mimic_String::setValue(std::string value)
    {
        if (!IsImplemented(node) || !IsAvailable(node) || !IsWritable(node)) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " is not writable!", -600);
        }
        try {
            return dynamic_cast<IString*>(node)->SetValue(value.c_str());
        }
        catch (...) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " write failed!", -610);
        }
    }

} /* namespace genSDK */
